﻿
#cs

Extract text from Smartling

1. In Smartling, scroll down as far as you can so that it loads all segments.
2. Then click underneath the last segment, and Ctrl+A, Ctrl+C, Ctrl+V into a text file.
3. Run this script on the text file.

NOTE: This does not extract any comments, so use a TranzVoo script that allows a separate shortcut for moving to the next segment, so that you can read the comments while you paste.

Script does this:

Split by double line break

Check if segment contains:
Add TranslationToggle Dropdown

If so, then it is a translatable

Split by line break

Then split by line break

SL = 1
Comments = 2
TL = 3

Remove one trailing space from SL

#ce

$FOD = FileOpenDialog ("Select raw text file", @ScriptDir, "TXT files (*.txt)|All files (*.*)")
$FO = FileOpen ($FOD, 128)
$FR = FileRead ($FO)

$zerowidthspace = BinaryToString ("0x200B", 2)
$FR = StringReplace ($FR, $zerowidthspace, "")

$SOV0 = FileOpen ($FOD & "_output1.txt", 129)
$SOV1 = FileOpen ($FOD & "_output_SL.txt", 129)
$SOV2 = FileOpen ($FOD & "_output_TL.txt", 129)
$SOV3 = FileOpen ($FOD & "_output2.txt", 129)

$FR = StringReplace ($FR, "Toggle Dropdown", "ISSEGMENT")

#cs
$FR = StringReplace ($FR, "In EditingToggle Dropdown", "ISSEGMENT")
$FR = StringReplace ($FR, "In TranslationToggle Dropdown", "ISSEGMENT")
$FR = StringReplace ($FR, "AssignToggle Dropdown", "ISSEGMENT")
$FR = StringReplace ($FR, "Submit to Next StepToggle Dropdown", "ISSEGMENT")
#ce

$FR = StringReplace ($FR, "Edit Translation  Add an Issue" & @CRLF, "") ; this occurs in mid-segment

$split1 = StringSplit ($FR, @CRLF & @CRLF, 1)

$linecount = 0

For $i = 1 to $split1[0]

If StringInStr ($split1[$i], "ISSEGMENT") Then

$split1[$i] = StringReplace ($split1[$i], "ISSEGMENT", "") ; added 29dec16

$split2 = StringSplit ($split1[$i], @CRLF, 1)

While (StringRight ($split2[1], 1) = " ")
$split2[1] = StringTrimRight ($split2[1], 1)
WEnd



$SL = $split2[1]
$comment = $split2[2]
$TL = $split2[3]

If $TL = "Edited in previous step" Then
$comment = "No comment"
$TL = $split2[2]
EndIf
If $TL = "Submit to Next Step" Then
$comment = "No comment"
$TL = $split2[2]
EndIf

#cs

If StringInStr ($comment, "", 1) Then
$comment = "" & $comment
EndIf

If StringInStr ($comment, "", 1) Then
$comment = "" & $comment
EndIf

If StringInStr ($comment, "", 1) Then
$comment = "" & $comment
EndIf

If StringInStr ($comment, "", 1) Then
$comment = "" & $comment
EndIf

#ce


Else
ContinueLoop
EndIf


$linecount = $linecount + 1
$linecount2 = $linecount
If $linecount < 10000 Then
$linecount2 = "0" & $linecount2 
EndIf
If $linecount < 1000 Then
$linecount2 = "0" & $linecount2 
EndIf
If $linecount < 100 Then
$linecount2 = "0" & $linecount2 
EndIf
If $linecount < 10 Then
$linecount2 = "0" & $linecount2 
EndIf

FileWrite ($SOV0, $SL & @TAB & $TL & @CRLF)
FileWrite ($SOV3, $linecount2 & @TAB & $SL & @TAB & $TL & @TAB & $comment & @CRLF)

; now do some replacements (can replace this later with an array based code)

$SLx = $SL

$SLx = StringRegExpReplace ($SLx, "(<a.+?>)", @CRLF & "$1" & @CRLF)
$SLx = StringRegExpReplace ($SLx, "(<span.+?>)", @CRLF & "$1" & @CRLF)
$SLx = StringRegExpReplace ($SLx, "(<font.+?>)", @CRLF & "$1" & @CRLF)
$SLx = StringRegExpReplace ($SLx, "(<button.+?>)", @CRLF & "$1" & @CRLF)

$SLx = StringReplace ($SLx, "</a>", @CRLF & "</a>" & @CRLF)
$SLx = StringReplace ($SLx, "<b>", @CRLF & "<b>" & @CRLF)
$SLx = StringReplace ($SLx, "</b>", @CRLF & "</b>" & @CRLF)
$SLx = StringReplace ($SLx, "<strong>", @CRLF & "<strong>" & @CRLF)
$SLx = StringReplace ($SLx, "</strong>", @CRLF & "</strong>" & @CRLF)
$SLx = StringReplace ($SLx, "<em>", @CRLF & "<em>" & @CRLF)
$SLx = StringReplace ($SLx, "</em>", @CRLF & "</em>" & @CRLF)
$SLx = StringReplace ($SLx, "<p>", @CRLF & "<p>" & @CRLF)
$SLx = StringReplace ($SLx, "</p>", @CRLF & "</p>" & @CRLF)
$SLx = StringReplace ($SLx, "<br>", @CRLF & "<br>" & @CRLF)
$SLx = StringReplace ($SLx, "</br>", @CRLF & "</br>" & @CRLF)
$SLx = StringReplace ($SLx, "<br/>", @CRLF & "<br/>" & @CRLF)
$SLx = StringReplace ($SLx, "<br />", @CRLF & "<br />" & @CRLF)
$SLx = StringReplace ($SLx, "</span>", @CRLF & "</span>" & @CRLF)
$SLx = StringReplace ($SLx, "</font>", @CRLF & "</font>" & @CRLF)
$SLx = StringReplace ($SLx, "</button>", @CRLF & "</font>" & @CRLF)

$SLx = StringReplace ($SLx, @CRLF & " ", @CRLF)
$SLx = StringReplace ($SLx, " " & @CRLF, @CRLF)

$TLx = $TL

$TLx = StringRegExpReplace ($TLx, "(<a.+?>)", @CRLF & "$1" & @CRLF)
$TLx = StringRegExpReplace ($TLx, "(<span.+?>)", @CRLF & "$1" & @CRLF)
$TLx = StringRegExpReplace ($TLx, "(<font.+?>)", @CRLF & "$1" & @CRLF)
$TLx = StringRegExpReplace ($TLx, "(<button.+?>)", @CRLF & "$1" & @CRLF)

$TLx = StringReplace ($TLx, "</a>", @CRLF & "</a>" & @CRLF)
$TLx = StringReplace ($TLx, "<b>", @CRLF & "<b>" & @CRLF)
$TLx = StringReplace ($TLx, "</b>", @CRLF & "</b>" & @CRLF)
$TLx = StringReplace ($TLx, "<strong>", @CRLF & "<strong>" & @CRLF)
$TLx = StringReplace ($TLx, "</strong>", @CRLF & "</strong>" & @CRLF)
$TLx = StringReplace ($TLx, "<em>", @CRLF & "<em>" & @CRLF)
$TLx = StringReplace ($TLx, "</em>", @CRLF & "</em>" & @CRLF)
$TLx = StringReplace ($TLx, "<p>", @CRLF & "<p>" & @CRLF)
$TLx = StringReplace ($TLx, "</p>", @CRLF & "</p>" & @CRLF)
$TLx = StringReplace ($TLx, "<br>", @CRLF & "<br>" & @CRLF)
$TLx = StringReplace ($TLx, "</br>", @CRLF & "</br>" & @CRLF)
$TLx = StringReplace ($TLx, "<br/>", @CRLF & "<br/>" & @CRLF)
$TLx = StringReplace ($TLx, "<br />", @CRLF & "<br />" & @CRLF)
$TLx = StringReplace ($TLx, "</span>", @CRLF & "</span>" & @CRLF)
$TLx = StringReplace ($TLx, "</font>", @CRLF & "</font>" & @CRLF)
$TLx = StringReplace ($TLx, "</button>", @CRLF & "</font>" & @CRLF)

$TLx = StringReplace ($TLx, @CRLF & " ", @CRLF)
$TLx = StringReplace ($TLx, " " & @CRLF, @CRLF)

FileWrite ($SOV1, "=====" & $linecount2 & "=====" & @CRLF & $SLx & @CRLF)
FileWrite ($SOV2, "=====" & $linecount2 & "=====" & @CRLF & $TLx & @CRLF)

Next
